<template>
    <div class="dispatching">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">配送管理</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getDispatchList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="salesNo" label="ID编码"></el-table-column>
                    <el-table-column prop="deliveryCustomer" label="配送客户/单位"></el-table-column>
                    <el-table-column prop="deliveryAddress" label="配送地址"></el-table-column>
                    <el-table-column prop="transportNo" label="运输单号"></el-table-column>
                    <el-table-column prop="weight" label="重量"></el-table-column>
                    <el-table-column prop="distributor" label="配送员"></el-table-column>
                    <el-table-column prop="transportVehicles" label="车牌号"></el-table-column>
                    <el-table-column prop="tel" label="手机号"></el-table-column>
                    <el-table-column label="状态">
                        <template v-slot="scope">
                            <div v-for="item in $store.state['dispatchStatus']" :key="item.value">
                                <span v-if="item.value == scope.row['status']">{{ item.label }}</span>
                            </div>
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addDispatch" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="销售单号">
                            <el-input v-model="formData.salesNo"></el-input>
                        </el-form-item>

                        <el-form-item label="配送客户/单位">
                            <el-input v-model="formData.deliveryCustomer"></el-input>
                        </el-form-item>

                        <el-form-item label="配送地址">
                            <el-input v-model="formData.deliveryAddress"></el-input>
                        </el-form-item>

                        <el-form-item label="运输单号">
                            <el-input v-model="formData.transportNo"></el-input>
                        </el-form-item>

                        <el-form-item label="重量(kg)">
                            <el-input v-model.number="formData.weight"></el-input>
                        </el-form-item>

                        <el-form-item label="配送员">
                            <el-input v-model="formData.distributor"></el-input>
                        </el-form-item>

                        <el-form-item label="车牌号">
                            <el-input v-model="formData.transportVehicles"></el-input>
                        </el-form-item>

                        <el-form-item label="手机号">
                            <el-input v-model="formData.tel"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addDispatch')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqDispatchList,
    reqAddDispatch,
    reqUpdateDispatch,
    reqDelDispatch
} from "@/api/storeTransportation.js";

const pageSize = 10;
const rules = {};

export default {
    name: "dispatching",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                salesNo: "DHG54G8415",
                deliveryCustomer: "xx食品有限公司",
                deliveryAddress: "深圳新思路",
                transportNo: 'J4544T4D4F54',
                weight: 2096,
                distributor: '李宜珊',
                transportVehicles: '浙A 1J8022',
                tel: '13856798458'
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 出仓管理列表
        this.getDispatchList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddDispatch(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getDispatchList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateDispatch(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getDispatchList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 出仓管理列表
        getDispatchList() {
            reqDispatchList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelDispatch(row.id)
                .then(res => {
                    console.log(res);
                    // 出仓管理列表
                    this.getDispatchList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 出仓管理列表
            this.getDispatchList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>